Attribute VB_Name = "Mod1"
'Manufactured by Manish Wadhera
'wadheramanish@hotmail.com
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Option Explicit
Declare Function CreateMenu Lib "user32" () As Long
Declare Function CreatePopupMenu Lib "user32" () As Long
Declare Function SetMenu Lib "user32" (ByVal hwnd As Long, ByVal hMenu As Long) As Long
Declare Function AppendMenu Lib "user32" Alias "AppendMenuA" (ByVal hMenu As Long, ByVal wFlags As Long, ByVal wIDNewItem As Long, ByVal lpNewItem As Any) As Long
Declare Function DestroyMenu Lib "user32" (ByVal hMenu As Long) As Long
Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (pDst As Any, pSrc As Any, ByVal ByteLen As Long)
Declare Function StretchBlt Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Const WM_INITMENUPOPUP = &H117
Const WM_MEASUREITEM = &H2C
Const WM_MENUSELECT = &H11F
Const WM_PAINT = &HF
Const WM_SYSCOMMAND = &H112
Const GWL_WNDPROC = -4
Const WM_COMMAND = &H111
Const WM_DRAWITEM = &H2B
Const WM_INITMENU = &H116

Public Type RECT
Left As Long
Top As Long
Right As Long
Bottom As Long
End Type

Type MEASUREITEMSTRUCT
CtlType As Long
CtlID As Long
itemID As Long
itemWidth As Long
itemHeight As Long
itemData As Long
End Type

Type DRAWITEMSTRUCT
CtlType As Long
CtlID As Long
itemID As Long
itemAction As Long
itemState As Long
hwndItem As Long
hdc As Long
rcItem As RECT
itemData As Long
End Type

Const MF_CHECKED = &H8&
Const MF_DISABLED = &H2&
Const MF_ENABLED = &H0&
Const MF_MENUBREAK = &H40&
Const MF_OWNERDRAW = &H100&
Const MF_POPUP = &H10&
Const MF_SEPARATOR = &H800&
Const MF_STRING = &H0&

Global lpPrevWndProc As Long
Global gHW As Long

Public f1 As Form
Public mnuPic As Long
Public mnumain As Long
Public menu1 As RECT

Public Sub MenuDimensions(XX As Long)
Dim YY As MEASUREITEMSTRUCT
CopyMemory YY, ByVal XX, Len(YY)
Select Case YY.itemID
Case 1
YY.itemHeight = 160
YY.itemWidth = 170
Case Else
End Select
CopyMemory ByVal XX, YY, Len(YY)
End Sub

Public Sub makethemenu(XX As Long)
Dim X1 As DRAWITEMSTRUCT
CopyMemory X1, ByVal XX, Len(X1)
Select Case X1.itemID
Case 1
menu1 = X1.rcItem
With menu1
StretchBlt X1.hdc, .Left, .Top, 200, 162, f1.picprev.hdc, 0, 0, f1.picprev.Width, f1.picprev.Height, vbSrcCopy
'StretchBlt X1.hdc, .Left, .Top, 200, 162, F1.picprev.hdc, 0, 0, F1.picprev.Width, F1.picprev.Height, vbSrcPaint
End With
Case Else
End Select
CopyMemory ByVal XX, X1, Len(X1)
End Sub

Public Sub buildthemenu()
mnumain = CreateMenu()
mnuPic = CreatePopupMenu()
AppendMenu mnumain, MF_POPUP, mnuPic, "Picture Menu"
AppendMenu mnuPic, MF_OWNERDRAW, 1, 0&
AppendMenu mnuPic, MF_SEPARATOR, 1, 0&
AppendMenu mnuPic, 0&, 2, "Exit"
End Sub

Public Sub traptheclick(mnuID)
Select Case mnuID
Case 2000
Unload f1
Exit Sub
Case 1
MsgBox "U clicked the Picture", vbInformation, "Picture in Menu"
Case 2
Unload f1
Case Else
Exit Sub
End Select
End Sub

Public Sub Hook(f As Form)
Set f1 = f
gHW = f.hwnd
lpPrevWndProc = SetWindowLong(gHW, GWL_WNDPROC, AddressOf WindowProc)
buildthemenu
End Sub

Function WindowProc(ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
On Error Resume Next
Select Case uMsg
Case WM_MENUSELECT
WindowProc = 0
Case WM_MEASUREITEM
MenuDimensions lParam
WindowProc = 0
Case WM_DRAWITEM
makethemenu lParam
WindowProc = 0
Case WM_PAINT
SetMenu gHW, mnumain
WindowProc = CallWindowProc(lpPrevWndProc, hwnd, uMsg, wParam, lParam)
Case WM_COMMAND
traptheclick (wParam)
WindowProc = CallWindowProc(lpPrevWndProc, hwnd, uMsg, wParam, lParam)
Case Else
WindowProc = CallWindowProc(lpPrevWndProc, hwnd, uMsg, wParam, lParam)
End Select
End Function
